#ifndef _include_StringSet_h_
#define _include_StringSet_h_

#include <map>
#include "string16.h"

class CodeContext;
class CtLocal;

#ifdef __xlC__
/* bug workaround for xlC STL bug */
#define _CONST_ 
#else
#define _CONST_ const 
#endif

class StringLitTable : public map< _CONST_ string16, unsigned, less< _CONST_ string16 > >
{
public:
  StringLitTable();
  size_t operator[]( const string16 & );
  
  void predeclare( ostream & ) const;
  void declare( ostream & ) const;
  void internAll( CodeContext & ) const;

  static const char name[];

private:
  static const char tableName[];
  static const CtLocal *stringType;
};


#endif // !_include_StringSet_h_
