/* -*- c++ -*- */

/* errors.h: Functions for reporting errors */

#ifndef _ERRORS_H_
#define _ERRORS_H_

#include <iosfwd>
#include "parse.h"

/* Report message at source position N. */
ostream &Message(const SourcePosn N = NoSourcePosition);

/* Report error at source position N. */
ostream &Error(const SourcePosn N = NoSourcePosition);

/* Report warning at source position N. */
ostream &Warning(const SourcePosn N = NoSourcePosition);

/* The number of times Error has been called. */
extern int NumErrors();

#endif
