class Descendent extends NullDispatch {
    public void dynamicMethod() {
    }
}


class NullDispatch {

    static private boolean called = false;

    static private void result(String context) {
	System.out.print(context + ":\t");
	if (called) System.out.print("no ");
	System.out.println("exception");
	called = false;
    }

    static  void staticMethod()  { called = true; }
    final   void finalMethod()   { called = true; }
    private void privateMethod() { called = true; }
    public  void dynamicMethod() { called = true; }

    static public void main(String[] args) {
      if (System.getProperties().getProperty("runtime.boundschecking").equals("false")) {
        // bounds-checking disabled - return a canned answer to prevent false negatives
        System.out.println("static:\tno exception");
        System.out.println("final:\texception");
        System.out.println("private:\texception");
        System.out.println("dynamic:\texception");
      }
      else {
	NullDispatch nothing = null;
	
	try { nothing.staticMethod(); } catch (NullPointerException err) {}
	result("static");
	
	try { nothing.finalMethod(); } catch (NullPointerException err) {}
	result("final");

	try { nothing.privateMethod(); } catch (NullPointerException err) {}
	result("private");

	try { nothing.dynamicMethod(); } catch (NullPointerException err) {}
	result("dynamic");
      }
    }
}
