all : passed


TEST  = $(notdir $(shell pwd))
EXEC  = $(TEST).exec
JAVAS = $(wildcard *.java)
BYTES = $(patsubst %.java,%.class,$(JAVAS))
OUTS  = out.byte out.exec

TOP     = ../../..
BACKEND = sequential
TCBUILD = $(TOP)/tcbuild/tcbuild --backend $(BACKEND) --generate tc-gen
REBUILD = rebuild


passed : $(OUTS)
	cmp $^ && touch $@

exec : $(EXEC)

out.exec : $(EXEC)
	./$< >$@ 2>&1

$(EXEC) : force $(REBUILD)
	$(MAKE) run-tcbuild

rebuild :
	$(MAKE) -C $(TOP)

run-tcbuild : $(JAVAS) $(TOP)/tc $(TOP)/runtime/backend/$(BACKEND)/libtitanium-$(BACKEND).a 
	$(TCBUILD) --outfile $(EXEC) $(TEST).java
	touch $@


byte : $(BYTES)

out.byte : $(BYTES)
	java $(TEST) >$@ 2>&1

%.class : %.java
	javac $^


clean :
	rm -f *.[oCH] $(EXEC) $(BYTES) $(OUTS) run-tcbuild passed core

force :
