package common::ammpi;
use base qw(common::tcrun);
use Cwd;

use strict;

#require 'tcrun';

########################################################################


sub run ($$@) {
    my $self = shift;
   
    my $MPIRUN_CMD = main::get_configure_mpirun_cmd();
    if ($ENV{TI_MPIRUN_CMD}) {
      $MPIRUN_CMD = $ENV{TI_MPIRUN_CMD};
    }

    my $pwd = cwd;
    my $cmd = join(" ",@_);

    $MPIRUN_CMD =~ s/%N/$self->{processes}/g;
    $MPIRUN_CMD =~ s/%n/$self->{processes}/g;

    $MPIRUN_CMD =~ s/%C/$cmd/g;
    $MPIRUN_CMD =~ s/%c/$cmd/g;

    $MPIRUN_CMD =~ s/%D/$pwd/g;
    $MPIRUN_CMD =~ s/%d/$pwd/g;

    $MPIRUN_CMD =~ s/%%/%/g;

    $self->SUPER::run(split / /,$MPIRUN_CMD); 
}

sub processes ($$) {
    my ($self, $processes) = @_;
    $self->{processes} = $processes;
}

########################################################################


1;
