#ifndef MONITOR_DIST_H
#define MONITOR_DIST_H

#define GRANTED 1
#define WAIT 0

#ifdef PTR64

#define ___MON_HANDLER1_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint addr0, juint addr1)

#define ___MON_HANDLER1(name) \
void ___monitor_ ## name ## _handler(void *token, juint addr0, juint addr1) { \
  tic_monitor_t *addr; \
  \
  SETHIGHWORD((julong *)&addr, addr0); \
  SETLOWWORD((julong *)&addr, addr1); \
  \
  __monitor_ ## name ## _handler(token, addr); \
} 

#define ___MON_HANDLER2_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint addr0, juint addr1, \
				            juint box0, juint box, juint proc0, juint proc)

#define ___MON_HANDLER2(name) \
void ___monitor_ ## name ## _handler(void *token, juint addr0, juint addr1, \
				     juint box0, juint box, juint proc0, juint proc) { \
  tic_monitor_t *addr; \
  \
  SETHIGHWORD((julong *)&addr, addr0); \
  SETLOWWORD((julong *)&addr, addr1); \
  \
  __monitor_ ## name ## _handler(token, addr, (Box)box, (Process)proc); \
} 

#define ___MON_HANDLER3_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint proc0, juint proc)

#define ___MON_HANDLER3(name) \
void ___monitor_ ## name ## _handler(void *token, juint proc0, juint proc) { \
  __monitor_ ## name ## _handler(token, (Process)proc); \
} 

#define ___MON_REPLY_HANDLER1_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint proc0, juint proc, \
				            juint proc1, juint signal_proc, juint box0, juint signal_box)

#define ___MON_REPLY_HANDLER1(name) \
void ___monitor_ ## name ## _handler(void *token, juint proc0, juint proc, \
				     juint proc1, juint signal_proc, juint box0, juint signal_box) { \
  __monitor_ ## name ## _handler(token, (Process)proc, (Process)signal_proc, (Box)signal_box); \
} 


#define ___MON_REPLY_HANDLER2_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint value0, juint value, \
					    juint proc0, juint proc)

#define ___MON_REPLY_HANDLER2(name) \
void ___monitor_ ## name ## _handler(void *token, juint value0, juint value, juint proc0, juint proc) { \
  __monitor_ ## name ## _handler(token, value, (Process)proc); \
} 

#define ___MON_REPLY_HANDLER3_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint proc0, juint proc)

#define ___MON_REPLY_HANDLER3(name) \
void ___monitor_ ## name ## _handler(void *token, juint proc0, juint proc) {  	\
  __monitor_ ## name ## _handler(token, (Process)proc); \
} 


#else

#define ___MON_HANDLER1_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint addr)

#define ___MON_HANDLER1(name) \
void ___monitor_ ## name ## _handler(void *token, juint addr) { \
  __monitor_ ## name ## _handler(token, (tic_monitor_t *)addr); \
} 

#define ___MON_HANDLER2_PTYPE(name) \
void ___monitor_ ## name ## _handler(void *token, juint addr, juint box, juint proc)

#define ___MON_HANDLER2(name) \
void ___monitor_ ## name ## _handler(void *token, juint addr, juint box, juint proc) { \
  __monitor_ ## name ## _handler(token, (tic_monitor_t *)addr, (Box)box, (Process)proc); \
}

#define ___MON_HANDLER3_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint proc)

#define ___MON_HANDLER3(name) \
void ___monitor_ ## name ## _handler(void *token, juint proc) { \
  __monitor_ ## name ## _handler(token, (Process)proc); \
} 

#define ___MON_REPLY_HANDLER1_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint proc, juint signal_proc, juint signal_box)

#define ___MON_REPLY_HANDLER1(name) \
void ___monitor_ ## name ## _handler(void *token, juint proc, \
				            juint signal_proc, juint signal_box) { \
  __monitor_ ## name ## _handler(token, (Process)proc, (Process)signal_proc, (Box)signal_box); \
} 

#define ___MON_REPLY_HANDLER2_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint value, juint proc)

#define ___MON_REPLY_HANDLER2(name) \
void ___monitor_ ## name ## _handler(void *token, juint value, juint proc) { \
  __monitor_ ## name ## _handler(token, value, (Process)proc); \
} 

#define ___MON_REPLY_HANDLER3_PTYPE(name) \
extern void ___monitor_ ## name ## _handler(void *token, juint proc)

#define ___MON_REPLY_HANDLER3(name) \
void ___monitor_ ## name ## _handler(void *token, juint proc) { \
  __monitor_ ## name ## _handler(token, (Process)proc); \
} 

#endif  /* PTR64 */

___MON_HANDLER1_PTYPE(notify_request);
___MON_HANDLER2_PTYPE(enter_request);
___MON_HANDLER2_PTYPE(exit_request);
___MON_HANDLER2_PTYPE(wait_request);
___MON_HANDLER2_PTYPE(notify_all_request);
___MON_HANDLER2_PTYPE(cancel_wait_request);
___MON_HANDLER3_PTYPE(signal_request);

___MON_REPLY_HANDLER1_PTYPE(exit_reply);
___MON_REPLY_HANDLER1_PTYPE(wait_reply);
___MON_REPLY_HANDLER2_PTYPE(enter_reply);
___MON_REPLY_HANDLER3_PTYPE(signal_reply);
___MON_REPLY_HANDLER3_PTYPE(notify_reply);

void __monitor_enter_request_handler(void *token, tic_monitor_t *mon, 
				     Box box, Process proc);
void __monitor_enter_reply_handler(void *token, int value,
				   Process proc);
void __monitor_exit_request_handler(void *token, tic_monitor_t *mon,
				    Box box, Process proc);
void __monitor_exit_reply_handler(void *token, Process proc,
				    Process signal_proc, Box signal_box);
void __monitor_wait_request_handler(void *token, tic_monitor_t *mon,
				    Box box, Process proc);
void __monitor_wait_reply_handler(void *token, Process proc,
				    Process signal_proc, Box signal_box);
void __monitor_notify_request_handler(void *token, tic_monitor_t *mon);
void __monitor_notify_reply_handler(void *token, Process proc);
void __monitor_notify_all_request_handler(void *token, tic_monitor_t *mon,
					  Box box, Process proc);
void __monitor_signal_request_handler(void *token, Process proc);
void __monitor_signal_reply_handler(void *token, Process proc);
void __monitor_cancel_wait_request_handler(void *token, tic_monitor_t *mon, 
				     Box box, Process proc);

#endif /*  MONITOR_DIST_H */
