
// Uses fake templates.  Script replaces V_ARITY with specified.

package ti.domains;

//
// ======
// Domain
// ======
//
// A domain is a group of points.
//

abstract public class tiDomainV_ARITY {

  public static tiDomainV_ARITY factory() {
    return new (tiDomains.region) tiMultiRectADomainV_ARITY();
  }
  public static tiDomainV_ARITY factory(tiRectDomainV_ARITY rd) {
    return new (tiDomains.region) tiMultiRectADomainV_ARITY(rd);
  }
  public static tiDomainV_ARITY factory(tiRectDomainV_ARITY [1d] rda) {
    return new (tiDomains.region) tiMultiRectADomainV_ARITY(rda);
  }
  public static tiDomainV_ARITY factory(Point<V_ARITY> [1d] pa) {
    return new (tiDomains.region) tiMultiRectADomainV_ARITY(pa);
  }

  // set relations
  public abstract tiDomainV_ARITY add(tiDomainV_ARITY d);
  public abstract tiDomainV_ARITY difference(tiDomainV_ARITY d);
  public abstract tiDomainV_ARITY multiply(tiDomainV_ARITY d);

  public abstract boolean isNull();
  public abstract boolean isNotNull();
  public abstract boolean isADR();
  public abstract boolean isEqual(tiDomainV_ARITY d);
  public abstract boolean isNotEqual(tiDomainV_ARITY d);
  public abstract boolean isSubset(tiDomainV_ARITY d);
  public abstract boolean isStrictSubset(tiDomainV_ARITY d);
  public abstract boolean isSuperset(tiDomainV_ARITY d);
  public abstract boolean isStrictSuperset(tiDomainV_ARITY d);

  // rect domain relations
  public abstract tiDomainV_ARITY add(tiRectDomainV_ARITY rd);
  public abstract tiDomainV_ARITY difference(tiRectDomainV_ARITY rd);
  public abstract tiDomainV_ARITY multiply(tiRectDomainV_ARITY rd);

  public abstract boolean isEqual(tiRectDomainV_ARITY rd);
  public abstract boolean isNotEqual(tiRectDomainV_ARITY rd);
  public abstract boolean isSubset(tiRectDomainV_ARITY rd);
  public abstract boolean isStrictSubset(tiRectDomainV_ARITY rd);
  public abstract boolean isSuperset(tiRectDomainV_ARITY rd);
  public abstract boolean isStrictSuperset(tiRectDomainV_ARITY rd);

  // point relations
  public abstract tiDomainV_ARITY add(Point<V_ARITY> p);
  public abstract tiDomainV_ARITY difference(Point<V_ARITY> p);
  public abstract tiDomainV_ARITY divide(Point<V_ARITY> p);
  public abstract tiDomainV_ARITY multiply(Point<V_ARITY> p);
  public abstract tiDomainV_ARITY permute(Point<V_ARITY> p);

  // shape information
  public int getArity() { return V_ARITY; }
  public abstract boolean doesContain(Point<V_ARITY> p);
  public abstract boolean isRectangular();
  public abstract int getNumPoints();
  public abstract Point<V_ARITY> getLowerBound();
  public abstract Point<V_ARITY> getUpperBound();
  public abstract Point<V_ARITY> getUpperMaxPoint();
  public abstract tiRectDomainV_ARITY getBoundingBox();
  public abstract tiRectDomainListV_ARITY getRectangles();
  public abstract String toString();
  public abstract tiRectDomainV_ARITY [1d] getRectDomains();
  public abstract tiRectDomainV_ARITY [1d] local getRectDomainsLocal();
  public abstract Point<V_ARITY> [1d] getPoints();
  public abstract Point<V_ARITY> [1d] local getPointsLocal();

  // dynamic optimizations
  public abstract tiDomainV_ARITY demote();

  // debugging
  private void println() {
    System.out.println(this);
  }

  // Hack for memory allocation - sets region used for all domain allocations and returns
  // old one. Use null for GCed allocation.
  public static Region setRegion(Region r) {
    Region old = tiDomains.region;
    tiDomains.region = r;
    return old;
  }
}


// Local variables:
// c-basic-offset: 2
// End:
