#include "gc.h"
#include "mem-local.h"
#include "java_string.h"
#include "native-utils.h"

void tossMonitorStateException_str(char * const ascii)
{
    const LP_JString message = java_string_build_8( (ascii?ascii:"") );
    m33throwIllegalMonitorStateExceptionLT6String4lang4javamT11NativeUtils4lang2ti( message );
    abort();			/* should never be reached */
}


void tossIllegalArgumentException_str(char * const ascii)
{

    const LP_JString message = java_string_build_8( (ascii?ascii:"") );
    m29throwIllegalArgumentExceptionLT6String4lang4javamT11NativeUtils4lang2ti( message );
    
    abort();                    /* should never be reached */
}

void tossNullPointerException_str(char * const ascii) 
{
    const LP_JString message = java_string_build_8( (ascii?ascii:"") );
    m25throwNullPointerExceptionLT6String4lang4javamT11NativeUtils4lang2ti( message );
    
    abort();                    /* should never be reached */
}

void tossArrayStoreException_str(char * const ascii) 
{
    const LP_JString message = java_string_build_8( (ascii?ascii:"") );
    m24throwArrayStoreExceptionLT6String4lang4javamT11NativeUtils4lang2ti( message );
    
    abort();                    /* should never be reached */
}

/* build a code-location string (used by __current_loc) */
char *build_loc_str(const char *funcname, const char *filename, int linenum) {
  int sz;
  char *loc;
  if (!funcname) funcname = "";
  if (!filename) filename = "*unknown file*";
  sz = strlen(funcname) + strlen(filename) + 20;
  loc = ti_malloc(sz);
  if (!loc) return "*out of mem*";
  if (*funcname)
    sprintf(loc,"%s%s at %s:%i", 
           funcname, 
           (funcname[strlen(funcname)-1] == ')'?"":"()"),
           filename, linenum);
  else
    sprintf(loc,"%s:%i", filename, linenum);
  return loc;
}


