#include "titanium.h"
#include "needs!T11PAPICounter4lang2ti.c.h"
#include "T11PAPICounter4lang2ti.h"
#include "T11NativeUtils4lang2ti.h"
#include "T5Class4lang4java.h"
#include "layout!ti5cdescmT11PAPICounter4lang2ti.h"

#ifdef USE_PAPI
#include <papi.h>
#endif

#include <assert.h>

void m9PAPI_initmT11PAPICounter4lang2ti();
void m13PAPI_shutdownmT11PAPICounter4lang2ti();
void m10PAPI_startImT11PAPICounter4lang2ti(jint eventSet);
jlong m9PAPI_stopIJmT11PAPICounter4lang2ti(jint eventSet, jlong value);
jint m12PAPI_cleanupImT11PAPICounter4lang2ti(jint eventSet);
void PAPI_init();
jint m20PAPI_initSingleEventIImT11PAPICounter4lang2ti(jint event, jint eventSet);
jint m15PAPI_checkEventImT11PAPICounter4lang2ti(jint event);
void PAPI_initSingleEvent(int event, int *tag); 
jint m10PAPI_availmT11PAPICounter4lang2ti();
static __tic_lock_t TI_PAPI_lock = __tic_lock_decl_initializer;
static int isInit = 0;

jint m10PAPI_availmT11PAPICounter4lang2ti(){
#ifdef USE_PAPI
  return (jint) 1;
#else 
  return (jint) 0;
#endif
}

jint m15PAPI_checkEventImT11PAPICounter4lang2ti(jint event){
#ifdef USE_PAPI
  int retval;

  retval = PAPI_query_event((int)(juint) event);
  if (retval == PAPI_OK){
    return (jint) 1;
  }
  else{
    return (jint) 0;
  }
#else
  return (jint) -1;
#endif
}

void m9PAPI_initmT11PAPICounter4lang2ti(){
#ifdef USE_PAPI
  __tic_lock(&TI_PAPI_lock);
  if (isInit == 0){
    isInit = 1;
    PAPI_init();
  }
  __tic_unlock(&TI_PAPI_lock);
#endif
}

void PAPI_init(){
#ifdef USE_PAPI
  int retval;
  retval = PAPI_library_init(PAPI_VER_CURRENT);
  if (retval != PAPI_VER_CURRENT){
      __tic_unlock(&TI_PAPI_lock);
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 0, (jint) retval);
  }  
  #ifdef HAVE_PAPI_MULTIPLEX_INIT
    /* DOB: older versions of PAPI lack this fn (eg. 1.1.5) */
    retval = PAPI_multiplex_init();
    if (retval != PAPI_OK){
        __tic_unlock(&TI_PAPI_lock);
        m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 1, (jint) retval);
    } 
  #endif
  retval = PAPI_set_debug(PAPI_VERB_ECONT);
  if (retval != PAPI_OK){
      __tic_unlock(&TI_PAPI_lock);
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 2, (jint) retval);
  }
  #ifdef MEMORY_SHARED
  retval = PAPI_thread_init((unsigned long (*)(void))(pthread_self), 0);
  if (retval != PAPI_OK){
    __tic_unlock(&TI_PAPI_lock);
    m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 3, (jint) retval);
  }  
  #endif
#endif 
}

jint m20PAPI_initSingleEventIImT11PAPICounter4lang2ti(jint event, jint eventSet){
#ifdef USE_PAPI
  int tmp = (int)(juint) eventSet;
  PAPI_initSingleEvent((int)(juint) event, &tmp);
  return (jint) tmp;
#else
  return (jint) -1;
#endif
}

void PAPI_initSingleEvent(int event, int *tag) {
#ifdef USE_PAPI
  int retval;

  retval = PAPI_query_event(event);
  if (retval != PAPI_OK){
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 4, (jint) retval);
  }
  retval = PAPI_create_eventset(tag);
  if (retval != PAPI_OK){
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 5, (jint) retval);
  }

  retval = PAPI_add_event(tag, event);
  if (retval == PAPI_ECNFLCT){
      m28throwTooManyCounterExceptionmT11PAPICounter4lang2ti();
  }

  if (retval != PAPI_OK){
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 6, (jint) retval);
  }
#endif
}

void m13PAPI_shutdownmT11PAPICounter4lang2ti(){
#ifdef USE_PAPI
    PAPI_shutdown();
#endif
}

void m10PAPI_startImT11PAPICounter4lang2ti(jint eventSet){
#ifdef USE_PAPI
  int retval;
  retval = PAPI_start((int)(juint) eventSet);
  if (retval != PAPI_OK){
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 7, (jint) retval);
  }
#endif
}

jlong m9PAPI_stopIJmT11PAPICounter4lang2ti(jint eventSet, jlong value){
#ifdef USE_PAPI
  long long int tmp[1];
  int retval;
  tmp[0] = 0;
  retval = PAPI_stop((int)(juint) eventSet, tmp);
  if (retval != PAPI_OK){
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 8, (jint) retval);
  }
  return (jlong) tmp[0];
#else
  return (jlong) -1;
#endif
}

jint m12PAPI_cleanupImT11PAPICounter4lang2ti(jint eventSet){
#ifdef USE_PAPI
  int tmp = (int)(juint) eventSet;
  int retval;
  retval = PAPI_cleanup_eventset(&tmp);
  if (retval != PAPI_OK){
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 9, (jint) retval);
  }
  retval = PAPI_destroy_eventset(&tmp);
  if (retval != PAPI_OK){
      m18throwPAPIExceptionIImT11PAPICounter4lang2ti((jint) 10, (jint) retval);
  }
  return (jint) tmp;
#else
  return (jint) -1;
#endif
}












