#ifndef _STOPTIFU_RECT1_H_
#define _STOPTIFU_RECT1_H_

typedef struct { int l0, h0; } rect1;


/*
extern rect1 rect1_compute_alpha(int n, const int *p, const int * const *v,
				 const int * const *inv, int k, int **r,
				 int dbg);
*/

#define rect1_copy(x) (x)

INLINE_MODIFIER rect1 rect1_intersection(rect1 r, rect1 s)
INLINE ({
  if (s.l0 > r.l0)
    r.l0 = s.l0;
  if (s.h0 < r.h0)
    r.h0 = s.h0;
  return r;
})

/* bounding box of union */
INLINE_MODIFIER rect1 rect1_rect1_approximate_union(rect1 r, rect1 s)
INLINE ({
  if (s.l0 < r.l0)
    r.l0 = s.l0;
  if (s.h0 > r.h0)
    r.h0 = s.h0;
  return r;
})

INLINE_MODIFIER bool rect1_is_empty(rect1 r)
INLINE ({
  return (r.l0 > r.h0);
})

INLINE_MODIFIER ivseti *rect1_to_ivseti(rect1 r)
INLINE ({
  if (rect1_is_empty(r))
    return ivseti_emptyset();
  return ivseti_single_interval(make_iinterval(r.l0, r.h0));
})

/* Return bounding box. */
INLINE_MODIFIER rect1 ivseti_to_rect1(ivseti *s)
INLINE ({
  rect1 result;
  ivseti_range(s, 0, &result.l0, &result.h0);
  return result;
})

INLINE_MODIFIER ivseti *ivseti_rect1_union(ivseti *r, rect1 s)
INLINE ({
  return ivseti_union(r, rect1_to_ivseti(s));
})

INLINE_MODIFIER ivseti *ivseti_rect1_intersection(ivseti *r, rect1 s)
INLINE ({
  return ivseti_intersection(r, rect1_to_ivseti(s));
})

/* bounding box of union */
INLINE_MODIFIER rect1 rect1_ivseti_approximate_union(rect1 r, ivseti *s)
INLINE ({
  return rect1_rect1_approximate_union(r, ivseti_to_rect1(s));
})

/* Is {rlo, ..., rhi} a superset of {slo, ..., shi} ?
   Assumes rlo <= rhi and slo <= shi. */
INLINE_MODIFIER bool range_superset(int rlo, int rhi, int slo, int shi)
INLINE ({
  return (rlo <= slo && rhi >= shi);
})

INLINE_MODIFIER bool rect1_is_shifted_subset(rect1 s, rect1 t, int d0)
INLINE ({
  return range_superset(t.l0, t.h0, s.l0 + d0, s.h0 + d0); 
})

/* is s shifted by some vector a subset of t? */
INLINE_MODIFIER bool rect1_ivseti_is_shifted_subset(rect1 s, ivseti *t, int d0)
INLINE ({
  return ivseti_is_shifted_subset1(rect1_to_ivseti(s), t, d0);
})

/* is s shifted by some vector a subset of t? */
INLINE_MODIFIER bool ivseti_rect1_is_shifted_subset(ivseti *s, rect1 t, int d0)
INLINE ({
  return rect1_is_shifted_subset(ivseti_to_rect1(s), t, d0);
})

/* Caller should free the result. */
#define rect1_to_string_body			\
{						\
  char *q = ALLOC(char, 100);			\
  sprintf(q, "{ %d - %d }", r.l0, r.h0);	\
  return q;					\
}

INLINE_MODIFIER char *rect1_to_string(rect1 r)
INLINE (rect1_to_string_body)
#undef rect1_to_string_body

#endif
